<template>
  <b-modal
    id="modalSaveDuplicateFiles"
    :model-value="visible"
    size="lg"
    hide-footer
    :title="$t('page.resource.modalSaveDuplicateFilesHeader')"
    @hidden="$emit('close')"
    @ok="$emit('accept')"
    @cancel="$emit('close')"
    @shown="$emit('shown')"
  >
    <div v-if="resourceTypeInformation && !resourceTypeInformation.canUpdate">
      {{ $t("page.resource.modalSaveDuplicatesFilesBodyWorm") }}
    </div>
    <div v-else>
      {{ $t("page.resource.modalSaveDuplicateFilesBody") }}
    </div>
    <br />
    <div
      v-for="(item, index) in uploadFileListReplaceFiles"
      :key="index"
      class="font-weight-bold"
    >
      {{ item.name }}
    </div>
    <br />
    <div>
      <b-button class="float-start" autofocus @click="$emit('close')">{{
        $t("page.resource.modalSaveDuplicateFilesBtnCancel")
      }}</b-button>
      <b-button class="modalButtonFloatCenter" @click="$emit('skip')">{{
        $t("page.resource.modalSaveDuplicateFilesBtnSkip")
      }}</b-button>
      <b-button
        :disabled="
          resourceTypeInformation && !resourceTypeInformation.canUpdate
        "
        class="float-end"
        style="justify-content: flex-end"
        @click="$emit('accept')"
        >{{ $t("page.resource.modalSaveDuplicateFilesBtnOverwrite") }}</b-button
      >
    </div>
  </b-modal>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../../../store";
import useProjectStore from "@/modules/project/store";

import type { FileInformation, VisitedResourceObject } from "../../../types";

import type { ResourceTypeInformationDto } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    uploadFileListReplaceFiles: {
      required: true,
      type: Array as PropType<FileInformation[]>,
    },
    visible: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    const resourceStore = useResourceStore();
    const projectStore = useProjectStore();

    return { resourceStore, projectStore };
  },
  computed: {
    resource(): null | VisitedResourceObject {
      return this.resourceStore.currentResource;
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
  },
});
</script>

<style scoped>
.modalButtonFloatCenter {
  position: absolute;
  left: 36%;
  right: 33%;
  white-space: nowrap;
}
.btn-secondary.disabled {
  pointer-events: none;
}
</style>
